## lipsia 1.6.0

=== CMakeLists.txt ===
PROJECT(LIPSIA)

# address warnings by cmake 2.6
cmake_minimum_required(VERSION 2.6)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0002 NEW)
endif(COMMAND cmake_policy)

IF(NOT UNIX)
  MESSAGE(FATAL_ERROR
    "The lipsia project only supports unix platforms, at the moment."
    )
ENDIF(NOT UNIX)

# add path for new modules
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	"${CMAKE_SOURCE_DIR}/cmake/Modules")

# configure install destinations
SET(LIPSIA_INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin")
# move private libs into separate directory (only relevant for shared libs)
SET(LIPSIA_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib/lipsia")
# target directory of the docs
SET(LIPSIA_INSTALL_DOC_DIR "${CMAKE_INSTALL_PREFIX}/share/doc/lipsia")

# add option to build shared libraries. The default is OFF.
# Building the three local libs as private shared libs, would reduce
# the memory footprint of LIPSIA especially on multi-user machines
# (even size of binaries would shrink by 30%).
# However, that does not seem to be possible since libvlh relies on symbols
# (e.g. 'pr') that are shared by all applications using the lib, which
# probably break the desired behavior. Maybe this could be changed?
#OPTION(BUILD_SHARED_LIBS "Toggle building shared libraries")

# look for VIA
FIND_PACKAGE(VIA REQUIRED)

# look for Qt3
FIND_PACKAGE(Qt3 REQUIRED)

# look for DCMTK
FIND_PACKAGE(DCMTK REQUIRED)

# look for nifticlib
FIND_PACKAGE(NIFTI REQUIRED)

# look for GSL
FIND_PACKAGE(GSL REQUIRED)

# look for fftw3
FIND_PACKAGE(FFTW3 REQUIRED)

# look for OpenGL
FIND_PACKAGE(OpenGL REQUIRED)

# look for ZLIB
FIND_PACKAGE(ZLIB REQUIRED)

# CPack support
# INCLUDE(CPack)

#
# Install global pieces
#

# add include directories
INCLUDE_DIRECTORIES(${VIA_INCLUDE_DIR}
  ${VIAIO_INCLUDE_DIR}
  ${DCMTK_INCLUDE_DIR}
  ${NIFTI_INCLUDE_DIR}
	${GSL_INCLUDE_DIR}
	)

INSTALL(DIRECTORY doc/html
  DESTINATION ${LIPSIA_INSTALL_DOC_DIR})

install(PROGRAMS lipsia-help DESTINATION ${LIPSIA_INSTALL_BIN_DIR})

# subprojects
ADD_SUBDIRECTORY(${CMAKE_SOURCE_DIR}/src)

=== src/CMakeLists.txt ===
ADD_SUBDIRECTORY(lib_arfit)
ADD_SUBDIRECTORY(lib_lipsia)
ADD_SUBDIRECTORY(lib_vlh)
ADD_SUBDIRECTORY(anatov)
ADD_SUBDIRECTORY(brutov)
ADD_SUBDIRECTORY(brutov2)
ADD_SUBDIRECTORY(niftov)
ADD_SUBDIRECTORY(v2ndlevel)
ADD_SUBDIRECTORY(vaddcovariates)
ADD_SUBDIRECTORY(valphasim)
ADD_SUBDIRECTORY(vanonym)
ADD_SUBDIRECTORY(varfit)
ADD_SUBDIRECTORY(vattrcopy)
ADD_SUBDIRECTORY(vattredit)
ADD_SUBDIRECTORY(vave)
ADD_SUBDIRECTORY(vbayes)
ADD_SUBDIRECTORY(vbayesgroup)
ADD_SUBDIRECTORY(vblobsize)
ADD_SUBDIRECTORY(vbrainmask)
ADD_SUBDIRECTORY(vbrainpeel)
ADD_SUBDIRECTORY(vcacp)
ADD_SUBDIRECTORY(vcatdesign)
ADD_SUBDIRECTORY(vcheckdesign)
ADD_SUBDIRECTORY(vcolorglm)
ADD_SUBDIRECTORY(vconvcoord)
ADD_SUBDIRECTORY(vdeform)
ADD_SUBDIRECTORY(vdelcereb)
ADD_SUBDIRECTORY(vdemon)
ADD_SUBDIRECTORY(vdifftimecourse)
ADD_SUBDIRECTORY(vdistortionCorrection)
ADD_SUBDIRECTORY(vdomulticomp)
ADD_SUBDIRECTORY(vdotrans)
ADD_SUBDIRECTORY(vextractparam)
ADD_SUBDIRECTORY(vfdr)
ADD_SUBDIRECTORY(vfunctrans)
ADD_SUBDIRECTORY(vgauss)
ADD_SUBDIRECTORY(vgen_wilcoxtable)
ADD_SUBDIRECTORY(vgendesign)
ADD_SUBDIRECTORY(vgetcontrast)
ADD_SUBDIRECTORY(vgetcovariates)
ADD_SUBDIRECTORY(vimagemask)
ADD_SUBDIRECTORY(vimagetimecourse)
ADD_SUBDIRECTORY(visotrop)
ADD_SUBDIRECTORY(vlcorr)
ADD_SUBDIRECTORY(vledit)
ADD_SUBDIRECTORY(vlserv)
ADD_SUBDIRECTORY(vlv)
ADD_SUBDIRECTORY(vlview)
ADD_SUBDIRECTORY(vmapscale)
ADD_SUBDIRECTORY(vmaskave)
ADD_SUBDIRECTORY(vmaskedit)
ADD_SUBDIRECTORY(vmetropolis)
ADD_SUBDIRECTORY(vmovcorrection)
ADD_SUBDIRECTORY(vmovcorrection2d)
ADD_SUBDIRECTORY(vmulticomp)
ADD_SUBDIRECTORY(vnormalize)
ADD_SUBDIRECTORY(vnumave)
ADD_SUBDIRECTORY(vonesample_ttest)
ADD_SUBDIRECTORY(vpaired_ttest)
ADD_SUBDIRECTORY(vpaired_wilcoxtest)
ADD_SUBDIRECTORY(vpreprocess)
ADD_SUBDIRECTORY(vpretty)
ADD_SUBDIRECTORY(vqview)
ADD_SUBDIRECTORY(vreg3d)
ADD_SUBDIRECTORY(vROIonesample_ttest)
ADD_SUBDIRECTORY(vROIpaired_ttest)
ADD_SUBDIRECTORY(vROIpaired_wilcoxtest)
ADD_SUBDIRECTORY(vROItwosample_ttest)
ADD_SUBDIRECTORY(vseltimesteps)
ADD_SUBDIRECTORY(vsendserv)
ADD_SUBDIRECTORY(vshowpts)
ADD_SUBDIRECTORY(vslicetime)
ADD_SUBDIRECTORY(vspectral)
ADD_SUBDIRECTORY(vspm2lipsia)
ADD_SUBDIRECTORY(vsulcogram)
ADD_SUBDIRECTORY(vsview)
ADD_SUBDIRECTORY(vtal)
ADD_SUBDIRECTORY(vtc)
ADD_SUBDIRECTORY(vtimestep)
ADD_SUBDIRECTORY(vtoanalyze)
ADD_SUBDIRECTORY(vtonifti)
ADD_SUBDIRECTORY(vtrialaverage)
ADD_SUBDIRECTORY(vtwosample_ttest)
ADD_SUBDIRECTORY(vwhiteglm)
ADD_SUBDIRECTORY(vwhitematter)
ADD_SUBDIRECTORY(vwilcoxon)
ADD_SUBDIRECTORY(vzmapborder)
ADD_SUBDIRECTORY(vzmax)
ADD_SUBDIRECTORY(dictov)

# needs Matlab?
#mattov vtomat

=== src/anatov/CMakeLists.txt ===
PROJECT(ANATOV)

ADD_EXECUTABLE(anatov anatov.c tools.c)
TARGET_LINK_LIBRARIES(anatov lipsia ${VIA_LIBRARY})

SET_TARGET_PROPERTIES(anatov
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

INSTALL(TARGETS anatov
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== src/brutov/CMakeLists.txt ===
PROJECT(BRUTOV)

ADD_EXECUTABLE(brutov brutov.C)
TARGET_LINK_LIBRARIES(brutov ${VIAIO_LIBRARY})

SET_TARGET_PROPERTIES(brutov
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

INSTALL(TARGETS brutov
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== src/brutov2/CMakeLists.txt ===
PROJECT(BRUTOV2)

ADD_EXECUTABLE(brutov2
    BrukerPV11Reader.C DoubleOption.C IOption.C  Logger.C StringListValidator.C
    BrukerPV11ToVistaConverter.C BrukerPV11ToNiftiConverter.C
    DoubleRangeValidator.C Image.C  OptionSet.C StringOption.C BrukerPV3Reader.C
    EmptyConverter.C ImageDatasetParameter.C OptionValues.C
    StringRegexpValidator.C BrukerPV3ToVistaConverter.C
    BrukerPV3ToNiftiConverter.C FileOption.C  IntegerOption.C Parameter.C
    VistaWriter.C NiftiWriter.C ConverterConfiguration.C FileRegexpValidator.C
    IntegerRangeValidator.C  RequiredValidator.C  brutov2.C ConverterFactory.C
    FileTypeValidator.C JCampDXParser.C StringListOption.C)

TARGET_LINK_LIBRARIES(brutov2 ${VIAIO_LIBRARY})

SET_TARGET_PROPERTIES(brutov2
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

INSTALL(TARGETS brutov2
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== src/dictov/CMakeLists.txt ===
# dictov
#
# CMakeLists.txt
# Author: Thomas Proeger

PROJECT(dictov)

# project specific variables
SET (SOURCES 
  NormVals.c
  dictov.C
)

SET(DCMTK_LIBS
  ${DCMTK_DCMDATA_LIBRARY}
  ${DCMTK_OFSTD_LIBRARY}
  pthread)

SET(LIBS
  lipsia					# should be done by a FindPackage script
  m
  ${ZLIB_LIBRARIES}
  ${GSL_GSL_LIBRARY}
  ${DCMTK_LIBS}
  ${VIA_LIBRARY}
  ${VIAIO_LIBRARY})

ADD_EXECUTABLE(dictov ${SOURCES})

SET_TARGET_PROPERTIES(dictov
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

TARGET_LINK_LIBRARIES(dictov ${LIBS})

INSTALL(TARGETS dictov
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== src/lib_arfit/CMakeLists.txt ===
PROJECT(LIBARFIT)

# configure source files
SET(LIBARFIT_SRC
   arfit.c arfit_schloegl.c arfit_via.c arfit_error.c  arfit_schneider.c
   gsl_matrix_wrapper.c)

ADD_LIBRARY(arfit ${LIBARFIT_SRC})
TARGET_LINK_LIBRARIES(arfit m ${GSL_GSL_LIBRARY} ${VIAIO_LIBRARY})

SET_TARGET_PROPERTIES(arfit
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

# only install when built as a shared lib
IF (BUILD_SHARED_LIBS)
  INSTALL(TARGETS arfit
    LIBRARY DESTINATION ${LIPSIA_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries)
ENDIF (BUILD_SHARED_LIBS)

=== src/lib_lipsia/CMakeLists.txt ===
PROJECT(LIBLIPSIA)

# configure source files
SET(LIBLIPSIA_SRC
    GeoInfo.c StatsConversions.c Talairach.c gsl_futils.c gsl_dutils.c via2gsl.c
    SmoothnessEstim.c wilcoxtables.c wilcox_pvals.c Convolve.c GaussConv.c
    GetVersion.c)

ADD_LIBRARY(lipsia ${LIBLIPSIA_SRC})
TARGET_LINK_LIBRARIES(lipsia m ${VIAIO_LIBRARY} ${GSL_GSL_LIBRARY})

SET_TARGET_PROPERTIES(lipsia
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

# only install when built as a shared lib
IF (BUILD_SHARED_LIBS)
  INSTALL(TARGETS lipsia
    LIBRARY DESTINATION ${LIPSIA_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries)
ENDIF (BUILD_SHARED_LIBS)

=== src/lib_vlh/CMakeLists.txt ===
PROJECT(LIBVLH)

# configure source files
SET(LIBVLH_SRC
    trilinear.C VLTools.C VLCorr.C showVImage.C pictureView.C prefs.C lView.C
    lLoad.C timecourse.C flow.C dialog.C bildWin.C preferences.C power.C
    rawCW.C rawpaint.C VCheck.C fenster1.C rawplot.C openGL.C bilderCW.C
    interpolator.cc)

QT_WRAP_CPP(vlh LIBVLH_MOC
    pictureView.h dialog.h bildWin.h preferences.h fenster1.h rawplot.h
    rawpaint.h rawCW.h openGL.h bilderCW.h lView.h VLCorr.h)

INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR} xpm)

ADD_LIBRARY(vlh ${LIBVLH_SRC} ${LIBVLH_MOC})
TARGET_LINK_LIBRARIES(vlh 
  ${QT_LIBRARIES}
  ${OPENGL_gl_LIBRARY}
  ${OPENGL_glu_LIBRARY}
  ${FFTW3_FFTW3_LIBRARY}
  lipsia)

# this libraries contains undefined symbols by design (e.g. 'pr')
# therefore it cannot be linked with '--no-undefined' !!
SET_TARGET_PROPERTIES(vlh
    PROPERTIES COMPILE_FLAGS -ansi)

# only install when built as a shared lib
IF (BUILD_SHARED_LIBS)
  INSTALL(TARGETS vlh
    LIBRARY DESTINATION ${LIPSIA_INSTALL_LIB_DIR} COMPONENT RuntimeLibraries)
ENDIF (BUILD_SHARED_LIBS)

=== src/mattov/CMakeLists.txt ===
PROJECT(mattov)

ADD_EXECUTABLE(mattov mattov.c)
TARGET_LINK_LIBRARIES(mattov lipsia ${VIA_LIBRARY})

SET_TARGET_PROPERTIES(mattov PROPERTIES
    LINK_FLAGS -Wl)

INSTALL(TARGETS mattov
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== src/niftov/CMakeLists.txt ===
PROJECT(NIFTOV)

INCLUDE_DIRECTORIES(${NIFTI_INCLUDE_DIR})

ADD_EXECUTABLE(niftov niftov.c niftsort.c niftfuncreorder.c)
TARGET_LINK_LIBRARIES(niftov lipsia ${VIA_LIBRARY} ${NIFTI_NIFTIIO_LIBRARY} ${NIFTI_ZNZ_LIBRARY} ${ZLIB_LIBRARY})

SET_TARGET_PROPERTIES(niftov
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

INSTALL(TARGETS niftov
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== src/v2ndlevel/CMakeLists.txt ===
PROJECT(V2NDLEVEL)

INCLUDE_DIRECTORIES(../lib_lipsia)

ADD_EXECUTABLE(v2ndlevel v2ndlevel.c Read2ndLevelDesign.c)
TARGET_LINK_LIBRARIES(v2ndlevel lipsia ${VIA_LIBRARY})

SET_TARGET_PROPERTIES(v2ndlevel
    PROPERTIES COMPILE_FLAGS -ansi
    LINK_FLAGS -Wl)

INSTALL(TARGETS v2ndlevel
        RUNTIME DESTINATION ${LIPSIA_INSTALL_BIN_DIR}
        COMPONENT RuntimeLibraries)

=== debian/changelog ===
lipsia (1.6.0-4ubuntu1) natty; urgency=low

  * Fix linking FTBFS with --no-add-needed.

 -- Ilya Barygin <barygin@gmail.com>  Sat, 12 Feb 2011 19:28:13 +0300

lipsia (1.6.0-4) unstable; urgency=low

  * Fix typos in package description (Closes: #565657). Thanks to
    Martin Eberhard Schauer.
  * Updated Debian copyright. Additionally put bibtex item with the cannonical
    citation into the 'references' field.
  * Adjust VCS information for the new repository home: debian-med.
  * Convert to source package format 3.0 (quilt). Turn git feature branches
    into a quilt patch series.
  * Switch from cdbs to debhelper's 'dh'. Bump compat level to 7.
  * Alter libnifti dependency from libnifti1-dev to libnifti-dev.
  * Switch maintainer to NeuroDebian team.

 -- Michael Hanke <michael.hanke@gmail.com>  Sun, 25 Jul 2010 09:13:40 -0400

lipsia (1.6.0-3) unstable; urgency=low

  * Add missing header includes for GCC 4.4 (Closes: #547284). Thanks to
    Martin Michlmayr.

 -- Michael Hanke <michael.hanke@gmail.com>  Fri, 18 Sep 2009 08:34:21 -0400

lipsia (1.6.0-2) unstable; urgency=low

  * Add missing items to debian/copyright. Thanks Torsten Weber.
  * Fix implicite pointer conversion detected by ia64 buildd
    (Closes: #546548).

 -- Michael Hanke <michael.hanke@gmail.com>  Mon, 14 Sep 2009 13:05:46 -0400

lipsia (1.6.0-1) unstable; urgency=low

  * Initial Debian packaging attempt. The is a complete rewrite of the orginal
    packaging effort done by the upstream developers (Closes: #521412).
  * Wrote manpage for LIPSIA and symlink it for all included binaries.
  * Compile internal libraries as SOs and install them into /usr/lib/lipsia.
    All binaries are configured with a corresponding RPATH setting.

 -- Michael Hanke <michael.hanke@gmail.com>  Wed, 02 Sep 2009 21:36:21 -0400

=== debian/control ===
Source: lipsia
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <michael.hanke@gmail.com>, Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~), cmake, fftw3-dev, libdcmtk1-dev, libgsl0-dev, libqt3-compat-headers, libqt3-mt-dev, libnifti-dev, libvia-dev (>= 1.4.1)
Standards-Version: 3.8.3.0
Homepage: http://www.cbs.mpg.de/institute/software/lipsia
Vcs-Browser: http://git.debian.org/?p=debian-med/lipsia.git
Vcs-Git: git://git.debian.org/git/debian-med/lipsia.git
XS-DM-Upload-Allowed: yes

Package: lipsia
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, via-bin
Recommends: dcmtk, lipsia-doc
Description: analysis suite for MRI and fMRI data
 Leipzig Image Processing and Statistical Inference Algorithms (LIPSIA)
 .
 This is a software package for the data processing and evaluation of
 functional magnetic resonance images. The analysis of fMRI data comprises
 various aspects including filtering, spatial transformation, statistical
 evaluation as well as segmentation and visualization. All these aspects are
 covered by LIPSIA. For the statistical evaluation, a number of well established
 and peer-reviewed algorithms were implemented in LIPSIA that allow an efficient
 and user-friendly processing of fMRI data sets. As the amount of data that must
 be handled is enormous, an important aspect in the development of LIPSIA was
 the efficiency of the software implementation.
 .
 LIPSIA operates exclusively on data in the VISTA data format. However, the
 package contains converters for medical image data in iBruker, ANALYZE  and
 NIfTI format -- converting VISTA images into NIfTI files is also supported.

Package: lipsia-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation for LIPSIA
 Leipzig Image Processing and Statistical Inference Algorithms (LIPSIA)
 .
 This package provides the LIPSIA documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f

CMAKE_FLAGS = \
    -DBUILD_SHARED_LIBS:BOOL=ON \
    -DCMAKE_INSTALL_RPATH="/usr/lib/lipsia" \
    -DCMAKE_SKIP_RPATH:BOOL=OFF

# one ring to rule them all ...
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_install:
	dh_auto_install
	# generate fake manpages for all commands
	if [ -f debian/lipsia.links ]; then rm debian/lipsia.links; fi
	for c in debian/tmp/usr/bin/* ; do \
		echo "/usr/share/man/man1/lipsia.1.gz /usr/share/man/man1/$$(basename $$c).1.gz" \
			>> debian/lipsia.links; \
	done

override_dh_shlibdeps:
	dh_shlibdeps -ldebian/lipsia/usr/lib/lipsia

=== debian/watch ===
version=3
ftp://lipsia.cbs.mpg.de/lipsia/TGZ/lipsia-(\d)\.(.*)\.tar\.gz \
  debian debian/repack.sh
